-- file: create.sql
-- Lifestat

drop sequence Hit_HitID_seq;
-- create sequence Hit_HitID_seq; -- Done automatically

drop sequence Hit_SessionID_seq;
create sequence Hit_SessionID_seq;

drop table Hit;
create table Hit(
	HitID		serial, -- int4 DEFAULT nextval('"hit_HitID_seq"'),
	SessionID	int4,
	CustomerID	int4,
	IPID		int4,
	AuthUser	text,
	AuthName	text,
	hitDatetime     timestamp,
	HostID		int4,
	URLID		int4,
	Status          int4,
	Size            int4,
	RefererHostID	int4,
	RefererURLID	int4,
	BrowserID	int4,
	TimeSpent	interval,
	XferTime	int4,
	MimeTypeID	int4
);
--                                                    cost per insert
create index Hit_hitID on Hit(HitID);
--create index Hit_CustomerID on Hit(CustomerID);
--create index Hit_IPID on Hit(IPID);
--create index Hit_hitDatetime on Hit(hitDatetime);
--create index Hit_HostID on Hit(HostID);
--create index Hit_URLID on Hit(URLID);
--create index Hit_Status on Hit(Status);
--create index Hit_RefererHostID on Hit(RefererHostID); -- 4 ms
--create index Hit_RefererURLID on Hit(RefererURLID); -- 7 ms
--create index Hit_BrowserID on Hit(BrowserID); -- 6 ms
----create index Hit_TimeSpent on Hit(TimeSpent);
--create index Hit_XferTime on Hit(XferTime);
--create index Hit_MimeTypeID on Hit(MimeTypeID);

create index Hit_hitDatetime_CustomerID on Hit(hitDatetime,CustomerID);
create index Hit_SessionID on Hit(SessionID);

drop sequence Customer_CustomerID_seq;
drop table Customer;
create table Customer(
	CustomerID	serial,
	CustomerText    text	-- (aeiwi.com)
);
create index Customer_CustomerID on Customer(CustomerID);
create index Customer_CustomerText on Customer(CustomerText);

drop sequence IP_IPID_seq;
drop table IP;
create table IP(
	IPID		serial,
	IPText		text,	-- (123.45.67.89)
	IPname		text	-- (dial-ip192.inet)
	IPdomain	text	-- (tele)
	IPcountry	text	-- (dk)
);
create index IP_IPID on IP(IPID);
create index IP_IPText on IP(IPText);

drop sequence Host_HostID_seq;
drop table Host;
create table Host(
	HostID		serial,
	HostText	text	-- (www.aeiwi.com)
);
create index Host_HostID on Host(HostID);
create index Host_HostText on Host(HostText);

drop sequence URL_URLID_seq;
drop table URL;
create table URL(
	URLID		serial,
--	URLMD5		text 	-- (MD5 af URLText)
	URLText		text 	-- (/cgi-bin/add?k=588)
);
create index URL_URLID on URL(URLID);
--create index URL_URLMD5 on URL(URLMD5);
create index URL_URLText on URL(URLText);

drop sequence Browser_BrowserID_seq;
drop table Browser;
create table Browser(
	BrowserID	serial,
	BrowserText	text,	-- (Mozilla 7/9.13)
	BrowserClass	int4
);
create index Browser_BrowserID on Browser(BrowserID);
create index Browser_BrowserText on Browser(BrowserText);

drop sequence MimeType_MimeTypeID_seq;
drop table MimeType;
create table MimeType(
	MimeTypeID	serial,
	MimeTypeText    text	-- (text/html)
);
create index MimeType_MimeTypeID on MimeType(MimeTypeID);
create index MimeType_MimeTypeText on MimeType(MimeTypeText);

drop sequence BrowserClass_BrowserClassID_seq;
drop table BrowserClass;
create table BrowserClass(
	BrowserClassID	serial,
	BrowserClassText	text	-- (Netscape 4.7x)
);
create index BrowserClass_BrowserClassID on BrowserClass(BrowserClassID);
create index BrowserClass_BrowserClassText on BrowserClass(BrowserClassText);


